﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace gammad
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        [DllImport("user32.dll")]
        public static extern IntPtr GetDC(IntPtr hWnd);

        [DllImport("gdi32.dll")]
        public unsafe static extern bool SetDeviceGammaRamp(IntPtr hDC, ushort* lpRamp);

        [DllImport("gdi32.dll")]
        public unsafe static extern int GetDeviceGammaRamp(IntPtr hDC, ushort* lpRamp);

        Timer tRead, tWrite;

        private void Form1_Load(object sender, EventArgs e)
        {
            tRead = new Timer();
            tWrite = new Timer();
            tRead.Tick += tRead_Tick;
            tWrite.Tick += tWrite_Tick;
        }

        private void _readc_CheckedChanged(object sender, EventArgs e)
        {
            tRead.Stop();
            tRead.Interval = Convert.ToInt32(_readv.Text);
            if (_readc.Checked)
            {
                System.IO.File.AppendAllText("gammad.log",
                    string.Format("{0} -- READER STARTED\r\n",
                    DateTime.UtcNow.ToString("yyyy-MM-dd, HH:mm:ss")), Encoding.UTF8);

                tRead.Start();
            }
        }

        private void _writec_CheckedChanged(object sender, EventArgs e)
        {
            tWrite.Stop();
            tWrite.Interval = Convert.ToInt32(_writev.Text);
            if (_writec.Checked)
                tWrite.Start();
        }

        private void _readone_Click(object sender, EventArgs e)
        {
            tRead_Tick(sender, e);
        }

        private void _writeone_Click(object sender, EventArgs e)
        {
            tWrite_Tick(sender, e);
        }

        void tWrite_Tick(object sender, EventArgs e)
        {
            int[] g = {
                _r.Value,
                _g.Value,
                _b.Value,
            };
            IntPtr hdc = Graphics.FromHwnd(IntPtr.Zero).GetHdc();
            unsafe
            {
                ushort* gArray = stackalloc ushort[3 * 256];
                ushort* idx = gArray;

                for (int j = 0; j < 3; j++)
                {
                    for (int i = 0; i < 256; i++)
                    {
                        int arrayVal = i * (g[j] + 128);

                        if (arrayVal > 65535)
                            arrayVal = 65535;

                        *idx++ = (ushort)arrayVal;
                    }
                }
                bool retVal = SetDeviceGammaRamp(hdc, gArray);
            }
        }

        int or, og, ob;
        void tRead_Tick(object sender, EventArgs e)
        {
            IntPtr hdc = Graphics.FromHwnd(IntPtr.Zero).GetHdc();
            int r, g, b;
            unsafe
            {
                ushort* gArray = stackalloc ushort[3 * 256];
                GetDeviceGammaRamp(hdc, gArray);

                r = (gArray[0 * 256 + 128] - (128 * 128)) / 128;
                g = (gArray[1 * 256 + 128] - (128 * 128)) / 128;
                b = (gArray[2 * 256 + 128] - (128 * 128)) / 128;
            }
            _r.Value = r;
            _g.Value = g;
            _b.Value = b;

            if (or != r ||
                og != g ||
                ob != b)
            {
                or = r;
                og = g;
                ob = b;
                System.IO.File.AppendAllText("gammad.log",
                    string.Format("{0} -- {1} -- {2} -- {3}\r\n",
                        DateTime.UtcNow.ToString("yyyy-MM-dd, HH:mm:ss"), r, g, b), Encoding.UTF8);
            }
        }
    }
}
